



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java多态实现原理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java多态实现原理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 20:41:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>众所周知，多态是面向对象编程语言的重要特性，它允许基类的指针或引用指向派生类的对象，而在具体访问时实现方法的动态绑定。C++ 和&nbsp;<a href="http://lib.csdn.net/base/javaee" rel="external nofollow noreferrer">Java</a>&nbsp;作为当前最为流行的两种面向对象编程语言，其内部对于多态的支持到底是如何实现的呢，本文对此做了全面的介绍。</p>
<p>注意到在本文中，指针和引用会互换使用，它们仅是一个抽象概念，表示和另一个对象的连接关系，无须在意其具体的实现。</p>
<h2>Java 的实现方式</h2>
<p>Java 对于方法调用动态绑定的实现主要依赖于方法表，但通过类引用调用和接口引用调用的实现则有所不同。总体而言，当某个方法被调用时，JVM 首先要查找相应的常量池，得到方法的符号引用，并查找调用类的方法表以确定该方法的直接引用，最后才真正调用该方法。以下分别对该过程中涉及到的相关部分做详细介绍。</p>
<h3>JVM 的结构</h3>
<p>典型的 Java 虚拟机的运行时结构如下图所示</p>
<h5>图 1.JVM 运行时结构</h5>
<p><img referrerpolicy="no-referrer"src="https://www.ibm.com/developerworks/cn/java/j-lo-polymorph/image003.jpg" /></p>
<p>此结构中，我们只探讨和本文密切相关的方法区 (method area)。当程序运行需要某个类的定义时，载入子系统 (class loader subsystem) 装入所需的 class 文件，并在内部建立该类的类型信息，这个类型信息就存贮在方法区。类型信息一般包括该类的方法代码、类变量、成员变量的定义等等。可以说，类型信息就是类的 Java 文件在运行时的内部结构，包含了改类的所有在 Java 文件中定义的信息。</p>
<p>注意到，该类型信息和 class 对象是不同的。class 对象是 JVM 在载入某个类后于堆 (heap) 中创建的代表该类的对象，可以通过该 class 对象访问到该类型信息。比如最典型的应用，在 Java 反射中应用 class 对象访问到该类支持的所有方法，定义的成员变量等等。可以想象，JVM 在类型信息和 class 对象中维护着它们彼此的引用以便互相访问。两者的关系可以类比于进程对象与真正的进程之间的关系。</p>
<h3>Java 的方法调用方式</h3>
<p>Java 的方法调用有两类，动态方法调用与静态方法调用。静态方法调用是指对于类的静态方法的调用方式，是静态绑定的；而动态方法调用需要有方法调用所作用的对象，是动态绑定的。类调用 (invokestatic) 是在编译时刻就已经确定好具体调用方法的情况，而实例调用 (invokevirtual) 则是在调用的时候才确定具体的调用方法，这就是动态绑定，也是多态要解决的核心问题。</p>
<p>JVM 的方法调用指令有四个，分别是 invokestatic，invokespecial，invokesvirtual 和 invokeinterface。前两个是静态绑定，后两个是动态绑定的。本文也可以说是对于 JVM 后两种调用实现的考察。</p>
<h3>常量池（constant pool）</h3>
<p>常量池中保存的是一个 Java 类引用的一些常量信息，包含一些字符串常量及对于类的符号引用信息等。Java 代码编译生成的类文件中的常量池是静态常量池，当类被载入到虚拟机内部的时候，在内存中产生类的常量池叫运行时常量池。</p>
<p>常量池在逻辑上可以分成多个表，每个表包含一类的常量信息，本文只探讨对于 Java 调用相关的常量池表。</p>
<p>CONSTANT_Utf8_info</p>
<p>字符串常量表，该表包含该类所使用的所有字符串常量，比如代码中的字符串引用、引用的类名、方法的名字、其他引用的类与方法的字符串描述等等。其余常量池表中所涉及到的任何常量字符串都被索引至该表。</p>
<p>CONSTANT_Class_info</p>
<p>类信息表，包含任何被引用的类或接口的符号引用，每一个条目主要包含一个索引，指向 CONSTANT_Utf8_info 表，表示该类或接口的全限定名。</p>
<p>CONSTANT_NameAndType_info</p>
<p>名字类型表，包含引用的任意方法或字段的名称和描述符信息在字符串常量表中的索引。</p>
<p>CONSTANT_InterfaceMethodref_info</p>
<p>接口方法引用表，包含引用的任何接口方法的描述信息，主要包括类信息索引和名字类型索引。</p>
<p>CONSTANT_Methodref_info</p>
<p>类方法引用表，包含引用的任何类型方法的描述信息，主要包括类信息索引和名字类型索引。</p>
<h5>图 2. 常量池各表的关系</h5>
<p><img referrerpolicy="no-referrer"src="https://www.ibm.com/developerworks/cn/java/j-lo-polymorph/image005.jpg" /></p>
<p>可以看到，给定任意一个方法的索引，在常量池中找到对应的条目后，可以得到该方法的类索引（class_index）和名字类型索引 (name_and_type_index), 进而得到该方法所属的类型信息和名称及描述符信息（参数，返回值等）。注意到所有的常量字符串都是存储在 CONSTANT_Utf8_info 中供其他表索引的。</p>
<h3>方法表与方法调用</h3>
<p>方法表是动态调用的核心，也是 Java 实现动态调用的主要方式。它被存储于方法区中的类型信息，包含有该类型所定义的所有方法及指向这些方法代码的指针，注意这些具体的方法代码可能是被覆写的方法，也可能是继承自基类的方法。</p>
<p>如有类定义 Person, Girl, Boy,</p>
<h5>清单 1</h5>
<div>
<pre class="prettyprint linenums"> class Person {<br />
 public String toString(){<br />
    return "I'm a person.";<br />
	 }<br />
 public void eat(){}<br />
 public void speak(){} 

 } 

 class Boy extends Person{<br />
 public String toString(){<br />
    return "I'm a boy";<br />
	 }<br />
 public void speak(){}<br />
 public void fight(){}<br />
 } 

 class Girl extends Person{<br />
 public String toString(){<br />
    return "I'm a girl";<br />
	 }<br />
 public void speak(){}<br />
 public void sing(){}<br />
 }</pre>
</div>
<p>当这三个类被载入到 Java 虚拟机之后，方法区中就包含了各自的类的信息。Girl 和 Boy 在方法区中的方法表可表示如下：</p>
<h5>图 3.Boy 和 Girl 的方法表</h5>
<p><img referrerpolicy="no-referrer"src="https://www.ibm.com/developerworks/cn/java/j-lo-polymorph/image007.jpg" /></p>
<p>可以看到，Girl 和 Boy 的方法表包含继承自 Object 的方法，继承自直接父类 Person 的方法及各自新定义的方法。注意方法表条目指向的具体的方法地址，如 Girl 的继承自 Object 的方法中，只有 toString() 指向自己的实现（Girl 的方法代码），其余皆指向 Object 的方法代码；其继承自于 Person 的方法 eat() 和 speak() 分别指向 Person 的方法实现和本身的实现。</p>
<p>Person 或 Object 的任意一个方法，在它们的方法表和其子类 Girl 和 Boy 的方法表中的位置 (index) 是一样的。这样 JVM 在调用实例方法其实只需要指定调用方法表中的第几个方法即可。</p>
<p>如调用如下：</p>
<h5>清单 2</h5>
<div>
<pre class="prettyprint linenums"> class Party{<br />
&hellip;<br />
 void happyHour(){<br />
 Person girl = new Girl();<br />
 girl.speak();<br />
&hellip;<br />
	 }<br />
 }</pre>
</div>
<p>当编译 Party 类的时候，生成&nbsp;<code>girl.speak()</code>的方法调用假设为：</p>
<p>Invokevirtual #12</p>
<p>设该调用代码对应着 girl.speak(); #12 是 Party 类的常量池的索引。JVM 执行该调用指令的过程如下所示：</p>
<h5>图 4. 解析调用过程</h5>
<p><img referrerpolicy="no-referrer"src="https://www.ibm.com/developerworks/cn/java/j-lo-polymorph/image009.jpg" /></p>
<p>JVM 首先查看 Party 的常量池索引为 12 的条目（应为 CONSTANT_Methodref_info 类型，可视为方法调用的符号引用），进一步查看常量池（CONSTANT_Class_info，CONSTANT_NameAndType_info ，CONSTANT_Utf8_info）可得出要调用的方法是 Person 的 speak 方法（注意引用 girl 是其基类 Person 类型），查看 Person 的方法表，得出 speak 方法在该方法表中的偏移量 15（offset），这就是该方法调用的直接引用。</p>
<p>当解析出方法调用的直接引用后（方法表偏移量 15），JVM 执行真正的方法调用：根据实例方法调用的参数 this 得到具体的对象（即 girl 所指向的位于堆中的对象），据此得到该对象对应的方法表 (Girl 的方法表 )，进而调用方法表中的某个偏移量所指向的方法（Girl 的 speak() 方法的实现）。</p>
<h3>接口调用</h3>
<p>因为 Java 类是可以同时实现多个接口的，而当用接口引用调用某个方法的时候，情况就有所不同了。Java 允许一个类实现多个接口，从某种意义上来说相当于多继承，这样同样的方法在基类和派生类的方法表的位置就可能不一样了。</p>
<h5>清单 3</h5>
<div>
<pre class="prettyprint linenums">interface IDance{<br />
   void dance();<br />
 } 

 class Person {<br />
 public String toString(){<br />
   return "I'm a person.";<br />
	 }<br />
 public void eat(){}<br />
 public void speak(){} 

 } 

 class Dancer extends Person<br />
 implements IDance {<br />
 public String toString(){<br />
   return "I'm a dancer.";<br />
	 }<br />
 public void dance(){}<br />
 } 

 class Snake implements IDance{<br />
 public String toString(){<br />
   return "A snake.";<br />
	 }<br />
 public void dance(){<br />
 //snake dance<br />
	 }<br />
 }</pre>
</div>
<h5>图 5.Dancer 的方法表（<a href="https://www.ibm.com/developerworks/cn/java/j-lo-polymorph/image011.jpg" rel="external nofollow noreferrer">查看大图</a>）</h5>
<p><img referrerpolicy="no-referrer"src="https://www.ibm.com/developerworks/cn/java/j-lo-polymorph/image011_small.JPG" /></p>
<p>可以看到，由于接口的介入，继承自于接口 IDance 的方法 dance（）在类 Dancer 和 Snake 的方法表中的位置已经不一样了，显然我们无法通过给出方法表的偏移量来正确调用 Dancer 和 Snake 的这个方法。这也是 Java 中调用接口方法有其专有的调用指令（invokeinterface）的原因。</p>
<p>Java 对于接口方法的调用是采用搜索方法表的方式，对如下的方法调用</p>
<p>invokeinterface #13</p>
<p>JVM 首先查看常量池，确定方法调用的符号引用（名称、返回值等等），然后利用 this 指向的实例得到该实例的方法表，进而搜索方法表来找到合适的方法地址。</p>
<p>因为每次接口调用都要搜索方法表，所以从效率上来说，接口方法的调用总是慢于类方法的调用的。</p>
<p>原文转自：http://blog.csdn.net/huangrunqing/article/details/51996424</p>
<p>原作者为 huangrunqing. 请尊重原作者版权</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4ljj8z.html">asp&period;net core 简单部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/3900ylm9.html">在Salesforce中处理Xml的生成与解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kzrd78.html">Python开发程序：ATM&plus;购物商城</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xx4re8.html">cf卡中，wtmp文件较大，导致磁盘空间满了</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xlmv9.html">linux 安装java环境&lpar;jdk&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e12k1j9.html">Ⅹ&period;spring的点点滴滴--IObjectPostProcessor&lpar;对象后处理器&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wnpywq.html">ELK之topbeat部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/96py44v8.html">redis入门指南-第7章-管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo34lnq.html">理解梯度下降法&lpar;Gradient Decent&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17k6gq.html">jdk切换小工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj17ol8.html">《JAVA程序设计》&lowbar;第五周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25dgklq.html">hbase的api操作之scan</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1v37xq.html">freemarker迭代list、map等常规操作，将数据放到模板中</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjlmxj9.html">git的基本操作---就看我这一篇就足够了！！！！！</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwy30y8.html">C&num; 与 SQL Server 的数据类型对应关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ro6g48.html">Ubuntu 13&period;10 安装Terminalx 后更改默认终端设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zynov19.html">理解tcp顺序释放操作和tcp的半关闭</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2o42oq.html">BZOJ3351&colon; &lbrack;ioi2009&rsqb;Regions&lpar;根号分治&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlww339.html">发起一个NetCore技术联盟促进NetCore技术应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em2y6j9.html">python学习day4之路</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/1q26gjx9.html">PHP正确的使用复数</a>
			</li>
						<li><a href="https://www.batexi.com/a/495n7rv9.html">IBM云的商业动作之我见（1）：IBM 收购 OpenStack 托管私有云公司 Blue Box &lbrack;IBM Acquired Blue Box&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx4zov9.html">css3中变形与动画（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q26y0x9.html">html5新增及废除属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdxxlz8.html">阿里云 CentOS6&period;5 ssh连接慢的解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rwm7eq.html">第8章 用户模式下的线程同步（2）&lowbar;临界区（CRITICAL&lowbar;SECTION）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gx6zzq.html">luogu1097统计数字&lbrack;noip2007提高组Day1T1&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q26e7o9.html">ef操作类</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlx0oeq.html">Oracle Update 语句语法与性能分析 - 多表关联</a>
			</li>
						<li><a href="https://www.batexi.com/a/495n1e09.html">一行命令搞定node&period;js 版本升级</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
